=== debian/changelog ===
dolphin-emu (2512+dfsg-2) unstable; urgency=medium

  * Team upload
  * Build with system minizip-ng (Closes: #1127491)
  * Correct minizip-ng pkgconf name

 -- Bastian Germann <bage@debian.org>  Sat, 14 Feb 2026 17:40:09 +0100

dolphin-emu (2512+dfsg-1) unstable; urgency=medium

  [ Bastian Germann ]
  * Exclude non-free zip spec (Closes: #1117727)

  * Drop unnecessary minizip patch

  [ Jordi Mallach ]
  * Update path to excluded libiconv

  [ Sébastien Noel ]
  * New upstream release
    - non-distributable documents removed from vendored minizip-ng
    - Fix build with CMake 4 (Closes: #1112853)
  * d/watch: add new components
  * d/gbp.conf: add new components
  * d/copyright: add glslang, rcheevos, Vulkan-Headers & VulkanMemoryAllocator to Files-Excluded
  * d/control: add Build-Depends on glslang-dev, glslang-tools & librcheevos-dev
  * updates patches for new release
  * d/rules: use USE_SYSTEM_MINIZIP-NG instead of USE_SYSTEM_MINIZIP
  * d/rules: update DOLPHIN_WC_DESCRIBE & DOLPHIN_WC_REVISION
  * d/rules: copy/clean new components on each build
  * d/control: bump Standards Version to 4.7.3
  * overrides lintian warning for 'hardening-no-pie', dolphin does not work with -fPIE
  * d/copyright: refresh for 2512
  * add Salsa CI

 -- Jordi Mallach <jordi@debian.org>  Mon, 09 Feb 2026 16:41:21 +0100
