=== debian/watch ===
version=4
opts=repack,compression=xz,filenamemangle=s/.+\/v?(\d[\d.]*)\.tar\.gz/dolphin-$1\.tar\.gz/,dversionmangle=s/\+dfsg\d?$//,repacksuffix=+dfsg \
  https://github.com/dolphin-emu/dolphin/tags .*/v?(\d[\d.]*)\.tar\.gz

opts="component=cpp-ipc, \
      mode=git, \
      pgpmode=none, \
      pretty=%cd.%h, \
      repack, \
      compression=xz, \
      dversionmangle=auto" \
https://github.com/mutouyun/cpp-ipc.git HEAD \
ignore

opts="component=cpp-optparse, \
      mode=git, \
      pgpmode=none, \
      pretty=%cd.%h, \
      repack, \
      compression=xz, \
      dversionmangle=auto" \
https://github.com/weisslj/cpp-optparse.git HEAD \
ignore

opts="component=imgui, \
      mode=git, \
      pgpmode=none, \
      pretty=%cd.%h, \
      repack, \
      compression=xz, \
      dversionmangle=auto" \
https://github.com/ocornut/imgui.git HEAD \
ignore

opts="component=implot, \
      mode=git, \
      pgpmode=none, \
      pretty=%cd.%h, \
      repack, \
      compression=xz, \
      dversionmangle=auto" \
https://github.com/epezent/implot.git HEAD \
ignore

opts="component=watcher, \
      mode=git, \
      pgpmode=none, \
      pretty=%cd.%h, \
      repack, \
      compression=xz, \
      dversionmangle=auto" \
https://github.com/e-dant/watcher.git HEAD \
ignore
